import React from 'react';
import { BoxProps } from '@mui/material/Box';
import { PasswordRequirement } from '../SetPassword';
export type PasswordRequirementsProps = BoxProps & {
    /**
     * The string to conduct the complexity checks against
     */
    passwordText: string;
    /**
     * Optional requirements to set password
     */
    passwordRequirements?: PasswordRequirement[];
};
/**
 * Component that renders all of the password requirement line items with check indicators.
 *
 * @param passwordText The string to conduct the complexity checks against
 * @param passwordRequirements Optional requirements to set password
 *
 * @category Component
 */
export declare const PasswordRequirements: React.FC<React.PropsWithChildren<PasswordRequirementsProps>>;
