import React from 'react';
export type PasswordRequirementsCheckProps = {
    /**
     * True if the line item should have a blue check (false for gray)
     */
    isChecked: boolean;
    /**
     * The text to display beside the check icon
     */
    label: string;
};
/**
 * Component that renders an individual password complexity line item with check indicator.
 *
 * @param isChecked True if the line item should have a blue check (false for gray)
 * @param label text to display beside the check icon
 *
 * @category Component
 */
export declare const PasswordRequirementsCheck: React.FC<React.PropsWithChildren<React.PropsWithChildren<PasswordRequirementsCheckProps>>>;
