"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CreatePasswordScreenBase = void 0;
var react_1 = __importDefault(require("react"));
var components_1 = require("../../components");
var SetPassword_1 = require("../../components/SetPassword");
var ErrorManager_1 = __importDefault(require("../../components/Error/ErrorManager"));
/**
 * The component renders a screen with the password and confirm password field for creating a new password.
 *
 * @param errorDisplayConfig configuration for customizing how errors are displayed
 * @param PasswordProps props passed from SetPassword component
 * @param WorkflowCardBaseProps props that will be passed to the WorkflowCard component
 * @param WorkflowCardHeaderProps props that will be passed to the WorkflowCardHeader component
 * @param WorkflowCardInstructionProps props that will be passed to the WorkflowCardInstructions component
 * @param WorkflowCardActionsProps props that will be passed to the WorkflowCardActions component
 *
 * @category Component
 */
var CreatePasswordScreenBase = function (props) {
    var cardBaseProps = props.WorkflowCardBaseProps || {};
    var headerProps = props.WorkflowCardHeaderProps || {};
    var instructionsProps = props.WorkflowCardInstructionProps || {};
    var actionsProps = props.WorkflowCardActionsProps || {};
    var passwordProps = props.PasswordProps || { onPasswordChange: function () { return ({}); } };
    var errorDisplayConfig = props.errorDisplayConfig;
    return (react_1.default.createElement(components_1.WorkflowCard, __assign({}, cardBaseProps),
        react_1.default.createElement(components_1.WorkflowCardHeader, __assign({}, headerProps)),
        react_1.default.createElement(components_1.WorkflowCardInstructions, __assign({}, instructionsProps)),
        react_1.default.createElement(components_1.WorkflowCardBody, null,
            react_1.default.createElement(ErrorManager_1.default, __assign({}, errorDisplayConfig),
                react_1.default.createElement(SetPassword_1.SetPassword, __assign({}, passwordProps)))),
        react_1.default.createElement(components_1.WorkflowCardActions, __assign({}, actionsProps))));
};
exports.CreatePasswordScreenBase = CreatePasswordScreenBase;
