import React from 'react';
import { VerifyCodeScreenProps } from './types';
/**
 * Component that renders a screen that prompts a user to enter the confirmation code
 * that was sent to the email address that they used to register.
 *
 * @param codeValidator function that validates the code text field
 * @param onResend function that is called when the resend link/button is clicked
 * @param resendInstructions text to display ahead of the resend link/button
 * @param resendLabel text to display for the resend link/button
 * @param initialValue the initial value for the code text field
 * @param verifyCodeInputLabel the label for the code text field
 * @param errorDisplayConfig configuration for customizing how errors are displayed
 * @param WorkflowCardBaseProps props that will be passed to the WorkflowCard component
 * @param WorkflowCardHeaderProps props that will be passed to the WorkflowCardHeader component
 * @param WorkflowCardInstructionProps props that will be passed to the WorkflowCardInstructions component
 * @param WorkflowCardActionsProps props that will be passed to the WorkflowCardActions component
 * @param verifyCodeTextFieldProps props to pass to the verify code field.
 *
 * @category Component
 */
export declare const VerifyCodeScreen: React.FC<VerifyCodeScreenProps>;
